---
apiVersion: v1
kind: PersistentVolumeClaim
metadata:
  name: rbd-pvc
spec:
  accessModes:
  - ReadWriteOnce
  resources:
    requests:
      storage: 1Gi
  storageClassName: bds1

---
apiVersion: v1
kind: ConfigMap
metadata:
  name: rbd-test
data:
  hello.conf: |
    server {
        listen 80;

        root /usr/share/nginx/html;
        try_files /index.html =404;

        expires -1;

        sub_filter_once off;
        sub_filter 'server_hostname' '$hostname';
        sub_filter 'server_address' '$server_addr:$server_port';
        sub_filter 'server_url' '$request_uri';
        sub_filter 'server_date' '$time_local';
        sub_filter 'request_id' '$request_id';
    }

---
apiVersion: v1
kind: Service
metadata:
  name: rbd-nginx1
  labels:
    app: rbd-nginx1
spec:
  selector:
    app: rbd-nginx1
  ports:
    - protocol: TCP
      port: 80
      targetPort: 80

---
apiVersion: apps/v1
kind: Deployment
metadata:
  name: rbd-nginx-deployment1
  labels:
    app: rbd-nginx1
spec:
  replicas: 1
  selector:
    matchLabels:
      app: rbd-nginx1
  template:
    metadata:
      labels:
        app: rbd-nginx1
    spec:
      containers:
      - name: nginx
        image: nginx
        imagePullPolicy: IfNotPresent
        ports:
          - containerPort: 80
            protocol: TCP
        volumeMounts:
          - mountPath: /usr/share/nginx/html
            name: www-data
          - name: rbd-test-config
            mountPath: /etc/nginx/conf.d
      volumes:
      - name: www-data
        persistentVolumeClaim:
          claimName: rbd-pvc
      - name: rbd-test-config
        configMap:
          name: rbd-test

---
apiVersion: extensions/v1beta1
kind: Ingress
metadata:
  name: rbd-test
  labels:
    app.kubernetes.io/name: rbd-test
  annotations:
    kubernetes.io/ingress.class: "nginx-internal"
spec:
  rules:
  - host: rbd-nginx1
    http:
      paths:
      - path: /
        backend:
          serviceName:  rbd-nginx1
          servicePort: 80
